﻿using Syncfusion.UI.Xaml.Diagram;
using Syncfusion.UI.Xaml.Diagram.Stencil;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Stencil_142815
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            //Node collection
            diagram.Nodes = new ObservableCollection<INode>();

            diagram.Connectors = new ObservableCollection<Connector>();

            diagram.PortVisibility = PortVisibility.Visible;

            diagram.PageSettings.PageBackground = new SolidColorBrush(Colors.White);
            AddSymbols("BPMNShapes", "Image", "Symbol3", this.Resources["FlowChart_StoredData"] as DataTemplate);
       
            symbolstencil.SelectedFilter = new SymbolFilterProvider() { SymbolFilter = Filter };
            (diagram.Info as IGraphInfo).ItemAdded += MainWindow_ItemAdded;


        }

        private bool Filter(SymbolFilterProvider sender, object symbol)
        {
            return true;
        }
        void MainWindow_ItemAdded(object sender, ItemAddedEventArgs args)
        {
            if (args.ItemSource == ItemSource.Stencil)
            {
                var dropedItem = args.Item as NodeViewModel;
                ///----------here I want to get "MyKeyObject"
                var d = dropedItem.Key;
                if (dropedItem != null)
                {
                    INodePort port1 = addPort(dropedItem, 0.5, 0.5);
                    dropedItem.Ports = new ObservableCollection<INodePort>()
                         {
                            port1
                         };

                }

            }

        }

        private INodePort addPort(INode node, double p1, double p2)
        {
            NodePort v = new NodePort()
            {
                Width = 11,
                Height = 11,
                NodeOffsetX = p1,
                NodeOffsetY = p2,
                Node=node,
                Shape = new EllipseGeometry() { RadiusX = 10, RadiusY = 10 },
                ShapeStyle = this.Resources["portstyle"] as Style,
               
            };
            return v;
        }

        //Adding Symbols
        public void AddSymbols(string group, string symbol, string key, DataTemplate template)
        {
            SymbolItem a = new SymbolItem();
            a.GroupName = group;
            a.Symbol = symbol;
            a.Key = key;
            a.SymbolTemplate = template;
             NodeViewModel node = new NodeViewModel()
            {
                Key="MyKeyObject",
                UnitHeight=70,
                UnitWidth=50,
                Shape=new RectangleGeometry() { Rect=new Rect(10,10,10,10)},
                ShapeStyle=this.Resources["shapeStyle"] as Style,

            };
            a.Symbol = node;
            //если еще ничего не добавляли
            if (symbolstencil.SymbolSource == null)
            {
              symbolstencil.SymbolSource = new SymbolCollection();
            }    
            ((SymbolCollection)symbolstencil.SymbolSource).Add(a);
           // return a;
        }


        private bool Filter(SymbolFilterProvider sender, ISymbol symbol)
        {
            return true;
        }
    }



}

